Index: sansview/perspectives/fitting/models.py
===================================================================
--- sansview/perspectives/fitting/models.py	(revision bb18ef1c74ed79eb0630f198735ad2b14e7913ab)
+++ sansview/perspectives/fitting/models.py	(revision c77d8592395f6684cf45ee976c1cac9db9c00110)
@@ -226,4 +226,8 @@
                          list1 = self.shape_indep_list,
                          list2 = self.struct_list )
+        self._fill_menu( menuinfo = ["Added models", added_models,
+                                            "List of additional models"],
+                                 list1= self.plugins,
+                                 list2 = self.struct_list)
         
         self._fill_simple_menu( menuinfo= ["Structure Factors",structure_factor,
@@ -231,7 +235,5 @@
                                 list1= self.struct_list )
         
-        self._fill_simple_menu( menuinfo = ["Added models", added_models,
-                                            "List of additional models"],
-                                 list1= self.plugins)
+        
         return 0
     
Index: sansview/perspectives/fitting/old_fit_thread.py
===================================================================
--- sansview/perspectives/fitting/old_fit_thread.py	(revision c77d8592395f6684cf45ee976c1cac9db9c00110)
+++ sansview/perspectives/fitting/old_fit_thread.py	(revision c77d8592395f6684cf45ee976c1cac9db9c00110)
@@ -0,0 +1,179 @@
+
+import sys, wx, logging
+import string, numpy, math
+from sans.guicomm.events import NewPlotEvent, StatusEvent  
+from sans.guiframe.calcthread import CalcThread
+import park
+from park.fitresult import FitHandler
+DEFAULT_BEAM = 0.005
+import time
+import thread
+ 
+class ConsoleUpdate(FitHandler):
+    """
+    Print progress to the console.
+    """
+    isbetter = False
+    """Record whether results improved since last update"""
+    progress_delta =  60
+    """Number of seconds between progress updates"""
+    improvement_delta = 5
+    """Number of seconds between improvement updates"""
+    def __init__(self,parent, quiet=False,progress_delta=60,improvement_delta=5):
+        """
+        If quiet is true, only print out final summary, not progress and
+        improvements.
+        """
+        self.parent= parent
+        self.progress_time = time.time()
+        self.progress_percent = 0
+        self.improvement_time = self.progress_time
+        self.isbetter = False
+        self.quiet = quiet
+        self.progress_delta = progress_delta
+        self.improvement_delta = improvement_delta
+
+    def progress(self, k, n):
+        """
+        Report on progress.
+        """
+        if self.quiet: return
+        t = time.time()
+        p = int((100*k)//n)
+        
+        # Show improvements if there are any
+        dt = t - self.improvement_time
+        if self.isbetter and dt > self.improvement_delta:
+            self.result.print_summary()
+            self.isbetter = False
+            self.improvement_time = t
+            
+            wx.PostEvent(self.parent, StatusEvent(status=\
+             "%d%% complete ..."%(p),type="update"))
+       
+        # Update percent complete
+        dp = p-self.progress_percent
+        if dp < 1: return
+        dt = t - self.progress_time
+        if dt > self.progress_delta:
+            if 1 <= dp <= 2:
+                self.progress_percent = p
+                self.progress_time = t
+                wx.PostEvent(self.parent, StatusEvent(status=\
+                                                      "%d%% complete ..."%(p),type="update"))
+       
+            elif 2 < dp <= 5:
+                if p//5 != self.progress_percent//5:
+                    wx.PostEvent(self.parent, StatusEvent(status=\
+                       "%d%% complete ..."%(5*(p//5)),type="update"))
+                    self.progress_percent = p
+                    self.progress_time = t
+            else:
+                if p//10 != self.progress_percent//10:
+                    self.progress_percent = p
+                    self.progress_time = t
+                    wx.PostEvent(self.parent, StatusEvent(status=\
+                   "%d%% complete ..."%(10*(p//10)),type="update"))
+        
+    def improvement(self):
+        """
+        Called when a result is observed which is better than previous
+        results from the fit.
+        """
+        self.isbetter = True
+    
+    def error(self, msg):
+        """
+        Model had an error; print traceback
+        """
+        if self.isbetter:
+            self.result.print_summary()
+        print msg
+
+    def finalize(self):
+        if self.isbetter:
+            self.result.print_summary()
+
+    def abort(self):
+        if self.isbetter:
+            self.result.print_summary()
+
+class FitThread(CalcThread):
+    """Thread performing the fit """
+    
+    def __init__(self,parent, fn,pars=None,cpage=None, qmin=None,qmax=None,ymin=None, ymax=None,
+                 xmin=None,xmax=None,
+                 completefn = None,
+                 updatefn   = None,
+                 yieldtime  = 0.01,
+                 worktime   = 0.01
+                 ):
+        CalcThread.__init__(self,completefn,
+                 updatefn,
+                 yieldtime,
+                 worktime)
+        self.parent = parent
+        self.fitter= fn
+        self.cpage= cpage
+        self.pars = pars
+        self.starttime = 0
+        self.qmin = qmin
+        self.qmax = qmax
+        self.xmin = xmin
+        self.xmax = xmax
+        self.ymin = ymin
+        self.ymax = ymax
+        self.done= False
+        wx.PostEvent(self.parent, StatusEvent(status=\
+                       "Start the computation  ",curr_thread=self,type="start"))
+    def isquit(self):
+        """
+             @raise KeyboardInterrupt: when the thread is interrupted
+        """
+        try:
+            CalcThread.isquit(self)
+        except KeyboardInterrupt:
+            wx.PostEvent(self.parent, StatusEvent(status=\
+                       "Calc %g interrupted"))
+            raise KeyboardInterrupt
+        
+    def update(self):
+        """
+            Is called when values of result are available
+        """
+        wx.PostEvent(self.parent, StatusEvent(status="Computing \
+        ... " ,curr_thread=self,type="update"))
+            
+    def compute(self):
+        """
+            Perform a fit 
+        """
+        try: 
+            self.starttime = time.time()
+            #Sending a progess message to the status bar
+            wx.PostEvent(self.parent, StatusEvent(status=\
+                       "Computing . ...",curr_thread=self,type="progress"))
+            #Handler used for park engine displayed message
+            handler= ConsoleUpdate(parent= self.parent,improvement_delta=0.1)
+            #Result from the fit
+            result = self.fitter.fit(handler= handler)
+        
+            elapsed = time.time()-self.starttime
+            self.complete(result= result,
+                          pars = self.pars,
+                          cpage= self.cpage,
+                          qmin = self.qmin,
+                          qmax = self.qmax,
+                          xmin= self.xmin,
+                          xmax= self.xmax,
+                          ymin = self.ymin,
+                          ymax = self.ymax, 
+                          elapsed=elapsed )
+        except KeyboardInterrupt:
+            # Thread was interrupted, just proceed and re-raise.
+            # Real code should not print, but this is an example...
+            raise
+        except:
+            wx.PostEvent(self.parent, StatusEvent(status="Fitting error: %s" % sys.exc_value))
+            return 
+    
Index: sansview/perspectives/fitting/old_fitpage1D.py
===================================================================
--- sansview/perspectives/fitting/old_fitpage1D.py	(revision 0b99881db3a31559d8bea44b140993d0b56d76fe)
+++ sansview/perspectives/fitting/old_fitpage1D.py	(revision c77d8592395f6684cf45ee976c1cac9db9c00110)
@@ -140,5 +140,9 @@
         # This sizer contains model list and chisqr value 
         #filling sizer4
+        ## structure combox box
+        self.structbox = wx.ComboBox(self, -1)
+        # define combox box
         self.modelbox = wx.ComboBox(self, -1)
+        
         self.tcChi    =  wx.StaticText(self, -1, str(0), style=wx.ALIGN_LEFT)
         self.tcChi.Hide()
@@ -149,6 +153,15 @@
         self.sizer4.Add(wx.StaticText(self,-1,'Model'),(iy,ix),(1,1)\
                   , wx.LEFT|wx.EXPAND|wx.ADJUST_MINSIZE, 15)
+        
         ix += 1
         self.sizer4.Add(self.modelbox,(iy,ix),(1,1),  wx.EXPAND|wx.ADJUST_MINSIZE, 0)
+        ix +=1
+        self.text_mult= wx.StaticText(self,-1,' x ')
+        self.sizer4.Add(self.text_mult,(iy,ix),(1,1),  wx.EXPAND|wx.ADJUST_MINSIZE, 0)
+        ix += 1
+        self.sizer4.Add(self.structbox,(iy,ix),(1,1),  wx.EXPAND|wx.ADJUST_MINSIZE, 0)
+        
+        
+        
         ix += 1
         self.sizer4.Add(self.text1_1,(iy,ix),(1,1),\
@@ -262,5 +275,5 @@
         # model on which the fit would be performed
         self.model=None
-        
+       
         self.back_up_model= None
         #dictionary of model name and model class
@@ -282,5 +295,6 @@
         self.Centre()
         self.Layout()
-        self.GrandParent.GetSizer().Layout()
+        
+        self.parent.GetSizer().Layout()
    
     def compute_chisqr2D(self):
@@ -289,5 +303,7 @@
             to the tcChi txtcrl
         """
-        flag=self.checkFitRange()
+        from sans.guiframe.utils import check_value
+        flag = check_value( self.qmin, self.qmax)
+        #flag=self.checkFitRange()
         res=[]
         if flag== True:
@@ -322,5 +338,7 @@
             to the tcChi txtcrl
         """
-        flag=self.checkFitRange()
+        from sans.guiframe.utils import check_value
+        flag = check_value( self.qmin, self.qmax)
+        #flag=self.checkFitRange()
         if flag== True:
             try:
@@ -367,9 +385,18 @@
         self.parent.GetSizer().Layout()
 
-        for item in self.model_list_box.itervalues():
-            name = item.__name__
-            if hasattr(item, "name"):
-                name = item.name
-            
+       
+        name= self.modelbox.GetString(self.modelbox.GetCurrentSelection())
+        form_factor =self.modelbox.GetClientData(self.modelbox.GetCurrentSelection())
+        struct_factor =self.structbox.GetClientData(self.structbox.GetCurrentSelection())
+       
+      
+        if form_factor!="separator":
+            if struct_factor != None and struct_factor.__name__ != "NoStructure":
+                from sans.models.MultiplicationModel import MultiplicationModel
+                self.model= MultiplicationModel(form_factor(),struct_factor())
+            else:
+                 self.model= form_factor() 
+            self.back_up_model= self.model.clone()
+            name= self.model.name
             if name == None:
                 self.qmin.Disable()
@@ -378,37 +405,48 @@
                 self.qmin.Enable()
                 self.qmax.Enable() 
-            
-            if name ==event.GetString():
-                try:
-                    self.model=item()
-                    self.back_up_model= self.model.clone()
-                    evt = ModelEventbox(model=self.model,name=name)
-                    wx.PostEvent(self.event_owner, evt)
-                    self.text1_1.Show()
-                    self.compute_chisqr()
-                    self.tcChi.Show()
-                except:
-                    raise #ValueError,"model.name is not equal to model class name"
-                break  
+            evt = ModelEventbox(model=self.model,name=name)
+            wx.PostEvent(self.event_owner, evt)   
+            self.text1_1.Show()
+            self.tcChi.Show()
+            self.compute_chisqr()
+        
+            
+        else:
+            self.model=None 
+            msg= " Select non - model value:%s ! Previous Model reloaded "%name 
+            wx.PostEvent(self.parent.parent, StatusEvent(status= msg))
+            
+        self.set_panel(self.model)
             
                  
     def onFit(self,event):
-        """ signal for fitting"""
-         
-        flag=self.checkFitRange()
-        self.set_manager(self.manager)
-     
+        """ 
+            signal for fitting .Perform single fit only
+        """
+        from sans.guiframe.utils import check_value
+        flag = check_value( self.qmin, self.qmax) 
+        
+        if not flag:
+            msg= "Fitting range invalid"
+            wx.PostEvent(self.parent.parent, StatusEvent(status= msg ))
+            return 
+        
+        if len(self.param_toFit) <= 0:
+            msg= "Select at least one parameter to fit"
+            wx.PostEvent(self.parent.parent, StatusEvent(status= msg ))
+            return 
+        
         self.qmin_x=float(self.qmin.GetValue())
         self.qmax_x =float( self.qmax.GetValue())
-        if len(self.param_toFit) >0 and flag==True:
-            self.manager.schedule_for_fit( value=1,fitproblem =None) 
-            if hasattr(self.data, "data"):
-                #single fit for Data2D
-                self.manager._on_single_fit(qmin=self.qmin_x,qmax=self.qmax_x,
-                                            ymin=self.data.ymin, ymax=self.data.ymax,
-                                            xmin=self.data.xmin,xmax=self.data.xmax)
-            else:
-                #single fit for Data1D
-                self.manager._on_single_fit(qmin=self.qmin_x,qmax=self.qmax_x)
+        
+        self.manager.schedule_for_fit( value=1,fitproblem =None) 
+        if hasattr(self.data, "data"):
+            #single fit for Data2D
+            self.manager._on_single_fit(qmin=self.qmin_x,qmax=self.qmax_x,
+                                        ymin=self.data.ymin, ymax=self.data.ymax,
+                                        xmin=self.data.xmin,xmax=self.data.xmax)
+        else:
+            #single fit for Data1D
+            self.manager._on_single_fit(qmin=self.qmin_x,qmax=self.qmax_x)
                 
             self.vbox.Layout()
@@ -416,24 +454,7 @@
             self.Layout()
             self.parent.GetSizer().Layout()
-        else:
-            wx.PostEvent(self.parent.parent, StatusEvent(status=\
-                            "Select at least one parameter to fit "))
+        
+            
   
-   
-    def _onTextEnter(self,event):
-        """
-            set a flag to determine if the fitting range entered by the user is valid
-        """
-      
-        try:
-            flag=self.checkFitRange()
-            if flag==True and self.model!=None:
-                self.manager.redraw_model(float(self.xmin.GetValue())\
-                                               ,float(self.xmax.GetValue()))
-        except:
-
-            wx.PostEvent(self.parent.GrandParent, StatusEvent(status=\
-                            "Drawing  Error:wrong value entered %s"% sys.exc_value))
-        
    
     
Index: sansview/perspectives/fitting/old_fitpanel.py
===================================================================
--- sansview/perspectives/fitting/old_fitpanel.py	(revision c77d8592395f6684cf45ee976c1cac9db9c00110)
+++ sansview/perspectives/fitting/old_fitpanel.py	(revision c77d8592395f6684cf45ee976c1cac9db9c00110)
@@ -0,0 +1,244 @@
+import wx
+import wx.aui
+import wx.lib
+import numpy
+import string ,re
+#import models
+_BOX_WIDTH = 80
+
+(FitPageEvent, EVT_FIT_PAGE)   = wx.lib.newevent.NewEvent()
+class FitPanel(wx.aui.AuiNotebook):    
+
+    """
+        FitPanel class contains fields allowing to fit  models and  data
+        @note: For Fit to be performed the user should check at least one parameter
+        on fit Panel window.
+       
+    """
+    ## Internal name for the AUI manager
+    window_name = "Fit panel"
+    ## Title to appear on top of the window
+    window_caption = "Fit Panel "
+    CENTER_PANE = True
+    def __init__(self, parent, *args, **kwargs):
+        wx.aui.AuiNotebook.__init__(self,parent,-1, style=wx.aui.AUI_NB_DEFAULT_STYLE  )
+        
+        
+        self.manager=None
+        self.parent=parent
+        self.event_owner=None
+        
+        pageClosedEvent = wx.aui.EVT_AUINOTEBOOK_PAGE_CLOSE
+        self.Bind(wx.aui.EVT_AUINOTEBOOK_PAGE_CLOSE, self.onClosePage)
+        #Creating the default page --welcomed page
+        self.about_page=None
+        from sans.guiframe.welcome_panel import PanelAbout
+        self.about_page = PanelAbout(self, -1)
+        self.AddPage(self.about_page,"welcome!")
+      
+       
+        #dictionary of miodel {model class name, model class}
+        self.model_list_box={}
+        ## list of structure factor
+        self.struct_list_box=[]
+        # save the title of the last page tab added
+        self.fit_page_name=[]
+        self.draw_model_name=None
+        #model page info
+        self.model_page_number=None
+       
+        self.model_page=None
+        self.sim_page=None
+        # increment number for model name
+        self.count=0
+        #updating the panel
+        self.Update()
+        self.Center()
+        
+        
+    def onClosePage(self, event):
+        """
+             close page and remove all references to the closed page
+        """
+        selected_page = self.GetPage(self.GetSelection())
+        page_number = self.GetSelection()
+        if self.sim_page != selected_page and selected_page!=self.about_page:
+            # remove the check box link to the model name of this page (selected_page)
+            if self.sim_page !=None :
+                self.sim_page.remove_model(selected_page)
+            #remove that page from page_finder of fitting module
+            page_finder=self.manager.get_page_finder() 
+            for page, value in page_finder.iteritems():
+                if page==selected_page:
+                    del page_finder[page]
+                    break
+            #Delete the page from notebook
+            if selected_page.name in self.fit_page_name:
+                self.fit_page_name.remove(selected_page.name)
+                
+            if selected_page.name== self.draw_model_name:
+                self.draw_model_name=None
+                self.model_page=None
+            if  page_number == 1:
+                self.model_page=None
+                self.draw_model_name=None
+            
+        elif selected_page==self.about_page:
+            self.about_page=None
+        else:
+            self.manager.sim_page=None  
+        
+        
+    def set_manager(self, manager):
+        """
+             set panel manager
+             @param manager: instance of plugin fitting
+        """
+        self.manager = manager
+
+        
+    def set_owner(self,owner):
+        """ 
+            set and owner for fitpanel
+            @param owner: the class responsible of plotting
+        """
+        self.event_owner=owner
+        
+    def add_sim_page(self):
+        """
+            Add the simultaneous fit page
+        """
+        from simfitpage import SimultaneousFitPage
+        self.sim_page = SimultaneousFitPage(self, id=-1)
+        self.AddPage(self.sim_page,caption="Simultaneous Fit",select=True)
+        self.sim_page.set_manager(self.manager)
+        return self.sim_page
+        
+    def add_fit_page( self,data ):
+        """ 
+            Add a fitting page on the notebook contained by fitpanel
+            @param data: data to fit
+            @return panel : page just added for futher used. is used by fitting module
+        """     
+        try:
+            name = data.name 
+        except:
+            name = 'Fit'
+        
+        if not name in self.fit_page_name :
+            from fitpage1D import FitPage1D
+            panel = FitPage1D(self,data, -1)
+            panel.name=name
+            
+            panel.set_manager(self.manager)
+            panel.set_owner(self.event_owner)
+            
+            self.AddPage(page=panel,caption=name,select=True)
+            panel.populate_box( self.model_list_box)
+            self.fit_page_name.append(name)
+    
+            return panel 
+        else:
+            return None 
+        
+    def _help_add_model_page(self,model,description,page_title, qmin=0, qmax=0.1, npts=50):
+        """
+            #TODO: fill in description
+            
+            @param qmin: mimimum Q
+            @param qmax: maximum Q
+            @param npts: number of Q points
+        """
+        from modelpage import ModelPage
+        #print "fitpanel model", model
+        panel = ModelPage(self,model,page_title, -1)
+        panel.set_manager(self.manager)
+        panel.set_owner(self.event_owner)
+        self.AddPage(page=panel,caption="Model",select=True)
+        panel.populate_box( self.model_list_box)
+        panel.name = page_title
+        self.draw_model_name=page_title
+        self.model_page_number=self.GetSelection()
+        self.model_page=self.GetPage(self.GetSelection())
+        
+        
+        # Set the range used to plot models
+        self.model_page.set_range(qmin, qmax, npts)
+        
+        # We just created a model page, we are ready to plot the model
+        #self.manager.draw_model(model, model.name)
+        #FOR PLUGIN  for somereason model.name is = BASEcomponent
+        self.manager.draw_model(model, page_title)
+        
+    def new_help_add_model_page(self,model,description,page_title, qmin=0, qmax=0.1, npts=50):
+        """
+            #TODO: fill in description
+            
+            @param qmin: mimimum Q
+            @param qmax: maximum Q
+            @param npts: number of Q points
+        """
+        ## storing page info
+        from pageInfo import  PageInfo
+        myinfo = PageInfo( self, model )
+        myinfo.model_list_box = self.model_list_box
+        from modelpage import ModelPage
+        
+        panel = ModelPage(self,myinfo,page_title)
+        panel.set_manager(self.manager)
+        panel.set_owner(self.event_owner)
+        
+        
+        self.AddPage(page=panel,caption="Model",select=True)
+        panel.populate_box( self.model_list_box)
+        panel.name = page_title
+        self.draw_model_name=page_title
+        self.model_page_number=self.GetSelection()
+        self.model_page=self.GetPage(self.GetSelection())
+        
+        
+        # Set the range used to plot models
+        self.model_page.set_range(qmin, qmax, npts)
+        
+        # We just created a model page, we are ready to plot the model
+        #self.manager.draw_model(model, model.name)
+        #FOR PLUGIN  for some reason model.name is = BASEcomponent
+        self.manager.draw_model(model, page_title)
+     
+        
+    def add_model_page(self,model,description,page_title, qmin=0, qmax=0.1, npts=50, topmenu=False):
+        """
+            Add a model page only one  to display any model selected from the menu or the page combo box.
+            when this page is closed than the user will be able to open a new one
+            
+            @param model: the model for which paramters will be changed
+            @param page_title: the name of the page
+            @param description: [Coder: fill your description!]
+            @param page_title: [Coder: fill your description!]
+            @param qmin: mimimum Q
+            @param qmax: maximum Q
+            @param npts: number of Q points
+        """
+        if topmenu==True:
+            if  self.draw_model_name ==None:
+                self._help_add_model_page(model,description,page_title, qmin=qmin, qmax=qmax, npts=npts)
+            else:
+                self.model_page.select_model(model, page_title)
+          
+    def get_current_page(self):
+        """
+            @return the current page selected
+        """
+        #return self.nb.GetCurrentPage()
+        return self.GetPage(self.GetSelection() )
+  
+    
+     
+    def set_model_list(self,dict):
+         """ 
+             copy a dictionary of model into its own dictionary
+             @param dict: dictionnary made of model name as key and model class
+             as value
+         """
+         self.model_list_box = dict
+  
